{{    ************************* Driver for  MAXIM-7219 alpha-numeric LED - Version 1.3 *****************************************
        
               ****** Dr.M.A.Siriwardena -  3/9/2013   ******
   Usage:
         Obj     Segment7  : "7_Seg_LED.Driver"
 
              Pub Main   | Value

                    Segment7.Start(load,clock,data)

  
                     Value := - 14

                 Segment7.CharOut(data,clock,load,Value)      
   
           
          
           
       ***** Displays values from -35 to + 35  ONLY ********

             Change code to display - Blank, decimal sign and  values > 20
}}
CON
'       clock mode & timing constants

    _clkmode    = xtal1 + pll16x       'set for 80 MHZ clock
    _xinfreq    = 5_000_000            '5 MHZ crystal in propeller chip circuit
   
    
'    **************************************************************************************************************
'      MAXIM-7219 7-segment LED display driver connections to prop chip ### CHANGE them to suit your needs ####

    'data   = 29                    'data in pin to pin 1 of MAX-7219
    'clock  = 28                    'clock signal in pin to pin 13 of MAX-7219
   ' load   = 20                    'load pulse in pin to pin 12 of MAX-7219

'   *******************************************************************************************************************  

'      MAX-7219 register constants

    digit_0         = 1
    digit_1         = 2
    digit_2         = 3
    digit_3         = 4
    digit_4         = 5
    digit_5         = 6            
    digit_6         = 7             
    digit_7         = 8              

    bdecode         = 9              'Sets up BCD decoding for each digit
    brite           = 10             'Sets up LED 7-segment display brightness level
    scan            = 11    '11             'sets up number of digits to be scanned
                                 '= number of digits - 1
    shutdn          = 12             'shut down 7-segment LED display
    display_test    = 15             'light up all LED 7-segment digits

    blank           = %1111          'MAX-7219 display code for a blank digit
    minus           = %1010          'MAX-7219 display code for a minus (-).
    DP              = %10000000      'decimal point


VAR

    word  index
    byte  Pntr                    'index to location in MAX-7219 to write data to
    byte  char                    'data to be sent to the MAX-7219
   

PUB Start(loadPin,ClockPin,DataPin)   ' PIN connections to Max 7219

    dira[loadPin]~~                  'setup prop pins 20[Load],Clock[28],Data[29]
    dira[ClockPin]~~                  'as outputs
    dira[DataPin]~~                  'to MAX_7219

    outa[loadPin]~                   'make the output pins low
    outa[ClockPin]~                   '
    outa[DataPin]~                   
          
   repeat index from 0 to 4
      pntr := Register_pointers[index]
      char := Register_values[index]
      Charout1(DataPin, ClockPin,LoadPin, pntr,Char)                                                                                        
       

  repeat index from digit_0 to digit_7   ' make all digits blank 
      pntr := index                  
      char := blank                  
      Charout1(DataPin, ClockPin,LoadPin, pntr, Char)                                                                      
    
Pub CharOut1(DataPin,ClockPin,LoadPin, Value1, Value2)
     outa[loadPin]~ 
    Shifting_Out(dataPin,clockPin, Value1)
    Shifting_Out(dataPin, clockPin, Value2)
    outa[loadPin]~~           
    
Pub Minus_Digit(DataPin, ClockPin,LoadPin,Value1, digit)        'digit is the physical number 1st digit,2nd Digit etc 
    pntr := digit
    char := minus
    CharOut1(DataPin, ClockPin,LoadPin, pntr, Char)

Pub Clear(DataPin,ClockPin, LoadPin)
     repeat index from digit_0 to digit_7   ' make all digits blank 
       pntr := index                  
       char := blank                  
       Charout1(DataPin, ClockPin,LoadPin, pntr, Char)


Pub CharOut(DataPin,ClockPin,LoadPin,Value)   'First 4 didit dsplay -
     outa[loadPin]~                           'digits starts as --> 4,3,2,1( from Rt.most is digit 1)  

 If Value => 0 and Value < 21    
    
   Case Value 
  
      0  :CharOut1(dataPin,clockPin,loadPin,8,0)
      1  :CharOut1(dataPin,clockPin,loadPin,8,1)
      2  :CharOut1(dataPin,clockPin,loadPin,8,2)
      3  :CharOut1(dataPin,clockPin,loadPin,8,3)
      4  :CharOut1(dataPin,clockPin,loadPin,8,4)
      5  :CharOut1(dataPin,clockPin,loadPin,8,5)
      6  :CharOut1(dataPin,clockPin,loadPin,8,6)
      7  :CharOut1(dataPin,clockPin,loadPin,8,7)
      8  :CharOut1(dataPin,clockPin,loadPin,8,8)
      9  :CharOut1(dataPin,clockPin,loadPin,8,9)
     10  :CharOut1(dataPin,clockPin,loadPin,8,1)
          CharOut1(dataPin,clockPin,loadPin,7,0)
     
     11   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,1)
     12   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,2)
     13   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,3)
     14   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,4)
     15   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,5)
     16   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,6)
     17   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,7)
     18   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,8)
     19   :CharOut1(dataPin,clockPin,loadPin,8,1)
           CharOut1(dataPin,clockPin,loadPin,7,9)
     20   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,0)
           
 elseif Value > 20 and Value < 36

   Case Value
           
     21   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,1)
     22   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,2)
     23   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,3)
     24   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,4)
     25   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,5)
     26   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,6)
     27   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,7)
     28   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,8)
     29   :CharOut1(dataPin,clockPin,loadPin,8,2)
           CharOut1(dataPin,clockPin,loadPin,7,9)
     30   :CharOut1(dataPin,clockPin,loadPin,8,3)
           CharOut1(dataPin,clockPin,loadPin,7,0)
     31   :CharOut1(dataPin,clockPin,loadPin,8,3)
           CharOut1(dataPin,clockPin,loadPin,7,1)
     32   :CharOut1(dataPin,clockPin,loadPin,8,3)
           CharOut1(dataPin,clockPin,loadPin,7,2)
     33   :CharOut1(dataPin,clockPin,loadPin,8,3)
           CharOut1(dataPin,clockPin,loadPin,7,3)
     34   :CharOut1(dataPin,clockPin,loadPin,8,3)
           CharOut1(dataPin,clockPin,loadPin,7,4)
     35   :CharOut1(dataPin,clockPin,loadPin,8,3)
           CharOut1(dataPin,clockPin,loadPin,7,5)
           
 elseif Value < 0  

   Case Value
      
     -1   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,1)
     -2   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,2)
     -3   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,3)
     -4   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,4)
     -5   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,5)
     -6   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,6)

     -7   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,7)

     -8   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,8)

     -9   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,9)

     -10   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,0)
     - 11  :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,1)
     -12   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,2)
     -13   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,3)
     -14   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,4)
     -15   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,5)
     -16   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,6)
     -17   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,7)
     -18   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,8)
     -19   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,9)
     -20    :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,0)

     -21   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
           CharOut1(dataPin,clockPin,loadPin,7,2)
           CharOut1(dataPin,clockPin, loadPin,6,1)
     -22  :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,2)
     -23   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,3)
     -24   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,4)
     -25   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,5)
     -26   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,6)
     -27   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,6)
     -28   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,8)
     -29   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,2)
            CharOut1(dataPin,clockPin, loadPin,6,9)
     -30   :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,3)
            CharOut1(dataPin,clockPin, loadPin,6,0)
     -31    :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,3)
            CharOut1(dataPin,clockPin, loadPin,6,1)

     -32    :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,3)
            CharOut1(dataPin,clockPin, loadPin,6,2)

     -33    :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,3)
            CharOut1(dataPin,clockPin, loadPin,6,3)

     -34    :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,3)
            CharOut1(dataPin,clockPin, loadPin,6,4)
     -35    :Minus_Digit(DataPin,ClockPin,LoadPin,8,8)
            CharOut1(dataPin,clockPin,loadPin,7,3)
            CharOut1(dataPin,clockPin, loadPin,6,5)
 
   outa[loadPin]~~
 
Pub CharOutLast(DataPin,ClockPin,LoadPin,Value)  'Last 4 digits display
     outa[loadPin]~


 If Value => 0 and Value < 21
    
   Case Value
  
      0  :CharOut1(dataPin,clockPin,loadPin,1,0)
      1  :CharOut1(dataPin,clockPin,loadPin,1,1)
      2  :CharOut1(dataPin,clockPin,loadPin,1,2)
      3  :CharOut1(dataPin,clockPin,loadPin,1,3)
      4  :CharOut1(dataPin,clockPin,loadPin,1,4)
      5  :CharOut1(dataPin,clockPin,loadPin,1,5)
      6  :CharOut1(dataPin,clockPin,loadPin,1,6)
      7  :CharOut1(dataPin,clockPin,loadPin,1,7)
      8  :CharOut1(dataPin,clockPin,loadPin,1,8)
      9  :CharOut1(dataPin,clockPin,loadPin,1,9)
     10  :CharOut1(dataPin,clockPin,loadPin,1,0)
          CharOut1(dataPin,clockPin,loadPin,2,1)

     11   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,1)
     12   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,2)
     13   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,3)
     14   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,4)
     15   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,5)
     16   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,6)
     17   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,7)
     18   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,8)
     19   :CharOut1(dataPin,clockPin,loadPin,2,1)
           CharOut1(dataPin,clockPin,loadPin,1,9)
     20   :CharOut1(dataPin,clockPin,loadPin,2,2)
           CharOut1(dataPin,clockPin,loadPin,1,0)
{           
 elseif Value < 0

   Case Value        
     
      -1   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,1)
     -2   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,2)
     -3   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,3)
     -4   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,4)
     -5   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,5)
     -6   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,6)

     -7   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,7)

     -8   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,8)

     -9   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
           CharOut1(dataPin,clockPin,loadPin,2,9)

     -10   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
            CharOut1(dataPin,clockPin,loadPin,2,1)
            CharOut1(dataPin,clockPin, loadPin,1,0)
     - 11  :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
            CharOut1(dataPin,clockPin,loadPin,2,1)
            CharOut1(dataPin,clockPin, loadPin,6,1)
     -12   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,2)
     -13   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,3)
     -14   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,4)
     -15   :Minus_Digit(DataPin,ClockPin,LoadPin,3,8)
            CharOut1(dataPin,clockPin,loadPin,7,1)
            CharOut1(dataPin,clockPin, loadPin,6,5)
  
 }


Pri Shifting_Out(Dpin, Cpin, Value)

    outa[Dpin]~                                               ' Data pin low
    dira[Dpin]~~                                              ' Set data as output high
    outa[Cpin]~                                               ' clock pin low
    dira[Cpin]~~                                              ' clock pin high
    
    Repeat 8                                                   
      outa[Cpin]~
      outa[Dpin] := Value >> 7                                 'shifting data to data out pin
      Value := Value <<  1                                       
      outa[Cpin]~~
      waitcnt(1000 +cnt)                                       ' pause
                                                                
  outa[Dpin]~                                                  ' setting data pin low after shifting data
  
DAT

'       MAX-7219 Register Address Map

Register_pointers
        byte  scan
        byte  brite
        byte  bdecode
        byte  shutdn
        byte  display_test

Register_values
        byte  7                        '8 digits to be used
        byte  15                       'full brightness
        byte  %11111111                '8 digits all BCD decoded
        byte  1                        'shutdown off
        byte  0                        'digits/segments test off


      
      